#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

/* #include "scoretable.h" */
#include "utils.h"
#include "structs.h"

void trace(int a, int b, short TRstart);
int scoreM(int a, int b, int g, int h);
int scoreIx(int a, int a_len, int b, int b_len, int g, int h);
int scoreIy(int a, int a_len, int b, int b_len, int g, int h);
long align(int a, int b);
void encode(int c_idx);
short matrix(int a, int b);
void bluntEnd();
void freePairwiseAlnStruct();

struct ALNdata aln;
extern struct seqStruct *seqLst;
extern int GAP_OPEN;
extern int GAP_EXT;
extern int NS_MATCH;
extern int NS_MISM;

/* ----------------------------------------------------------------------- */

void encode(int c_idx){
  
  int b, i=0;

  fprintf(stdout, "Preparing input data for RNAsalsa process ..\n");
  
  while(seqLst[i].name != NULL) {
    if(i == c_idx) {
      i++;
      continue;
    }
    
    seqLst[i].letter=(struct LETTERdata*)space((seqLst[i].length+1)*sizeof(struct LETTERdata));
    for(b=0; b<seqLst[i].length; b++){
      seqLst[i].letter[b].nucl = seqLst[i].sequence[b];
    }
    seqLst[i].letter[b].nucl = '\0';
    i++;
  }
  
  fprintf(stdout, ".. done.\n");

}

/* ----------------------------------------------------------------------- */

long align(int a, int b){

  int z;
  short TRstart;
  
  TRstart = matrix(a, b);
  
  fprintf(stdout, "  .. done. Alignment score: %li\n", aln.score);
  
  z = seqLst[a].length + seqLst[b].length +1;
  aln.alignment = (struct LETTERdata**)space(3*sizeof(struct LETTERdata*));
  aln.alignment[0] = (struct LETTERdata*)space(z*sizeof(struct LETTERdata));
  aln.alignment[1] = (struct LETTERdata*)space(z*sizeof(struct LETTERdata));
  aln.alignment[2] = NULL;
  
  trace(a, b, TRstart);
  b++;
 
  return z;
}

/* ----------------------------------------------------------------------- */

short matrix(int a, int b){

  short TRstart;
  int h, f=0, g;   /* h -> 1,2,3 */
  int x, y; /* 2 Achsen in der Matrix   ->   a = x-Achse, b = y-Achse */
  int hh, gg;  /*  Zaehler  */
  
  aln.seqname = (char**)space(2*sizeof(char*));
  aln.seqname[0] = seqLst[a].name;
  aln.seqname[1] = seqLst[b].name;

  aln.SCmatrix = (int***)space(3*sizeof(int**));
  aln.TRmatrix=(char***)space(3*sizeof(char**));
  
	for(h=0; h<3; h++) {
		aln.TRmatrix[h] = (char**)space((seqLst[b].length)*sizeof(char*));
		for(gg = 0; gg < (seqLst[b].length); gg++){
			aln.TRmatrix[h][gg]=(char*) space ((seqLst[a].length)*sizeof(char));
		}
	}
	
	for(h=0; h<3; h++){
		aln.SCmatrix[h]=(int**) space ((seqLst[b].length+1)*sizeof(int*));
		for(gg = 0; gg <= (seqLst[b].length); gg++){
			aln.SCmatrix[h][gg]=(int*) space ((seqLst[a].length+1)*sizeof(int));
		}
	}
  
  /* for(h=0; h<3; h++)    aln.SCmatrix[h][0]=(int*)space((seqLst[a].length+1)*sizeof(int)); */
  for(hh=0; hh <= (seqLst[a].length); hh++){
    aln.SCmatrix[0][0][hh]=f;
    aln.SCmatrix[1][0][hh]=f;
    aln.SCmatrix[2][0][hh]=f;
  }
  
  for(gg = 1; gg <= (seqLst[b].length); gg++){
   /*  for(h=0; h<3; h++){
      aln.SCmatrix[h][g]=(int*)space((seqLst[a].length+1)*sizeof(int));
      aln.TRmatrix[h][g-1]=(char*)space((seqLst[a].length+1)*sizeof(char));
      aln.SCmatrix[h][g][0]=f;
    } */

    for(hh = 1; hh <= (seqLst[a].length); hh++){
	
      aln.SCmatrix[0][gg][hh] = scoreM(a, b, gg, hh);
      aln.SCmatrix[1][gg][hh] = scoreIx(a, seqLst[a].length, b, seqLst[b].length, gg, hh);
      aln.SCmatrix[2][gg][hh] = scoreIy(a, seqLst[a].length, b, seqLst[b].length, gg, hh);
    }
	
   free(aln.SCmatrix[0][gg-1]);
    free(aln.SCmatrix[1][gg-1]);
    free(aln.SCmatrix[2][gg-1]);
	
	
  }

 /*  g=g-1;
  h=h-1; */

  gg--; hh--;
   
 /*  printf("%i %i %i %i\n", gg, hh, seqLst[b].length, seqLst[a].length); */

  if((aln.SCmatrix[0][gg][hh] > aln.SCmatrix[1][gg][hh]) &&
     (aln.SCmatrix[0][gg][hh] > aln.SCmatrix[2][gg][hh])){
    aln.score = aln.SCmatrix[0][gg][hh];
    TRstart = 0;
  }
  if((aln.SCmatrix[1][gg][hh] >= aln.SCmatrix[2][gg][hh]) &&
     (aln.SCmatrix[1][gg][hh] >= aln.SCmatrix[0][gg][hh])){
    aln.score = aln.SCmatrix[1][gg][hh];
    TRstart = 1;
  }
  if((aln.SCmatrix[2][gg][hh] > aln.SCmatrix[1][gg][hh]) &&
     (aln.SCmatrix[2][gg][hh] >= aln.SCmatrix[0][gg][hh])){
    aln.score = aln.SCmatrix[2][gg][hh];
    TRstart = 2;
  }
  
  free(aln.SCmatrix[0][gg]);
  free(aln.SCmatrix[1][gg]);
  free(aln.SCmatrix[2][gg]);
  free(aln.SCmatrix[0]);
  free(aln.SCmatrix[1]);
  free(aln.SCmatrix[2]);
  free(aln.SCmatrix);
  free(aln.seqname);
 
  return(TRstart);
}

/* ----------------------------------------------------------------------- */

void trace(int a, int b, short TRstart){
  
  int x, y, z, i, r=1, s=1;
  short d;
  struct LETTERdata empty;
  
  empty.nucl = '-';
  empty.dotbracket = '.';
  
  x = seqLst[a].length;
  y = seqLst[b].length;
  z = x+y+1;
  d = TRstart;
  
  for(i=0; i<z; i++){
    aln.alignment[0][i].nucl = '-';
    aln.alignment[1][i].nucl = '-';
  }
  z--;
  aln.alignment[0][z].nucl = 0;
  aln.alignment[1][z].nucl = 0;
  z--;
  x--;
  y--;

  while(x || y || r || s){
    if(d==0){
      if(r)   aln.alignment[0][z] = seqLst[a].letter[x];
      if(s)   aln.alignment[1][z] = seqLst[b].letter[y];
      switch(aln.TRmatrix[d][y][x]){
      case '1':     d=0;	break;
      case '2':     d=1;	break;
      case '3':     d=2;	break;
      default: fprintf(stderr, "Fatal error 1 in traceback!\n");  exit(1);
      }
      z--;
      if(x)  x--;
      else  r=0;
      if(y)  y--;
      else s=0;
      continue;
    }
    if(d==1){
      if(r)   aln.alignment[0][z] = seqLst[a].letter[x];
      aln.alignment[1][z] = empty;
      switch(aln.TRmatrix[d][y][x]){
      case '1':     d=0;	break;
      case '2':     d=1; 	break;
      case '3':     d=2;	break;
      default: fprintf(stdout, "Fatal error 2 in traceback!\n");  exit(2);
      }
      z--;
      if(x) x--;
      else r=0;
      if(!x && !y && !r && s)  d=2;
      continue;
    }
    if(d==2){
      aln.alignment[0][z] = empty;
      if(s)   aln.alignment[1][z] = seqLst[b].letter[y];
      switch(aln.TRmatrix[d][y][x]){
      case '1':     d=0;	break;
      case '2':     d=1; 	break;
      case '3':     d=2;	break;
      default: fprintf(stdout, "Fatal error 3 in traceback!\n");  exit(3);
      }
      z--;
      if(y)   y--;
      else   s=0;
      if(!x && !y && !s && r)  d=1;
      continue;
    }
  }
  for(x=0; x<3; x++){
    for(y=0; y<seqLst[b].length; y++){
      free(aln.TRmatrix[x][y]);
    }
    free(aln.TRmatrix[x]);
  }
  free(aln.TRmatrix);
  bluntEnd();
}

/* ----------------------------------------------------------------------- */

int scoreM(int a, int b, int g, int h){
  
  int s, sM, sIx, sIy;
  
  int matching_bp[6][6] = {
   /*  A  C  G  U  T  else*/
      {1, 0, 0, 0, 0, 0}, /* A */
      {0, 1, 0, 0, 0, 0}, /* C */
      {0, 0, 1, 0, 0, 0}, /* G*/
      {0, 0, 0, 1, 1, 0}, /* U */   /* T==U..w/o.effect.introduced.191108 */
      {0, 0, 0, 1, 1, 0}, /* T */
      {0, 0, 0, 0, 0, 0}, /* else */
  };
  
  int x, y;
  
  h = h-1;
  g = g-1;
  
  if(seqLst[a].letter[h].nucl == 'A') x = 0;
  else if(seqLst[a].letter[h].nucl == 'C') x = 1;
  else if(seqLst[a].letter[h].nucl == 'G') x = 2;
  else if(seqLst[a].letter[h].nucl == 'U') x = 3;
  else if(seqLst[a].letter[h].nucl == 'T') x = 4;
  else x = 5;
	
  if(seqLst[b].letter[g].nucl == 'A') y = 0;
  else if(seqLst[b].letter[g].nucl == 'C') y = 1;
  else if(seqLst[b].letter[g].nucl == 'G') y = 2;
  else if(seqLst[b].letter[g].nucl == 'U') y = 3;
  else if(seqLst[b].letter[g].nucl == 'T') y = 4;
  else y = 5;
  
  if(matching_bp[x][y])   s = NS_MATCH;
  else   s = NS_MISM;

  /*  if(seqLst[a].letter[h].dotbracket == seqLst[b].letter[g].dotbracket)  s = NS_MATCH; */
  /*   else   s=NS_MISM; */

  sM = aln.SCmatrix[0][g][h] + s;
  sIx = aln.SCmatrix[1][g][h] + s;
  sIy = aln.SCmatrix[2][g][h] + s;
  
  if((sM >= sIx) && (sM >= sIy)){
    aln.TRmatrix[0][g][h]='1';
    return(sM);
  }
  if((sIx > sM) && (sIx >= sIy)){
    aln.TRmatrix[0][g][h]='2';
    return(sIx);
  }
  if((sIy > sM) && (sIy > sIx)){
    aln.TRmatrix[0][g][h]='3';
    return(sIy);
  }
  return(0);
}

/* ----------------------------------------------------------------------- */

int scoreIx(int a, int a_len, int b, int b_len, int g, int h){
  
  /* fuegt in y-Achse, seq. b, vertikal, ein gap ein  */
  
  int sM, sIx, sIy;
  
  sM = aln.SCmatrix[0][g][h-1] + GAP_OPEN;
  sIx = aln.SCmatrix[1][g][h-1] + GAP_EXT;
  sIy = aln.SCmatrix[2][g][h-1] + GAP_OPEN;
  
 if(g == b_len)   sIx = aln.SCmatrix[1][g][h-1];
 /*  wenn g == strlen(b-vertikal)-1 , dann muss GAP_EXT == 0 sein */
  
  if((sM >= sIx) && (sM >= sIy)){
    aln.TRmatrix[1][g-1][h-1]='1';
    return(sM);
  }
  if((sIx > sM) && (sIx >= sIy)){
    aln.TRmatrix[1][g-1][h-1]='2';
    return(sIx);
  }
  if((sIy > sM) && (sIy > sIx)){
    aln.TRmatrix[1][g-1][h-1]='3';
    return(sIy);
  }
  return(0);
}

/* ----------------------------------------------------------------------- */

int scoreIy(int a, int a_len, int b, int b_len, int g, int h){

  int sM, sIx, sIy;

  sM = aln.SCmatrix[0][g-1][h] + GAP_OPEN;
  sIx = aln.SCmatrix[1][g-1][h] + GAP_OPEN;
  sIy = aln.SCmatrix[2][g-1][h] + GAP_EXT;
  
  if(h == a_len)   sIy = aln.SCmatrix[2][g-1][h];
  
  if((sM >= sIx) && (sM >= sIy)){
    aln.TRmatrix[2][g-1][h-1]='1';
    return(sM);
  }
  if((sIx > sM) && (sIx > sIy)){
    aln.TRmatrix[2][g-1][h-1]='2';
    return(sIx);
  }
  if((sIy > sM) && (sIy >= sIx)){
    aln.TRmatrix[2][g-1][h-1]='3';
    return(sIy);
  }
  return(0);
}

/* ------------------------------------------------------------------- */

void bluntEnd(){

  int a=0, b=0, min=1000000, d=0, e;
  struct LETTERdata *temp =NULL;
  
  while(aln.alignment[a]){
    while(aln.alignment[a][b].nucl){
      if(aln.alignment[a][b].nucl == '-')      b++;
      else break;
    }
    if(b<min) min=b;
    a++;
    b=0;
  }
  
  while(aln.alignment[0][d].nucl)       d++;
  a=0;
  b=0;
  e=min;
  
  while(aln.alignment[a]){
    temp=(struct LETTERdata*)space((d-min+1)*sizeof(struct LETTERdata));
    while(aln.alignment[a][e].nucl){
      temp[b] = aln.alignment[a][e];
      b++;
      e++;
    }
    temp[b].nucl = 0;
    free(aln.alignment[a]);
    aln.alignment[a]=(struct LETTERdata*)space((d-min+1)*sizeof(struct LETTERdata));
    b=0;
    while(temp[b].nucl){
      aln.alignment[a][b] = temp[b];
      b++;
    }
    aln.alignment[a][b].nucl = 0;
    free(temp);
    b=0;
    e=min;
    a++;
  }
}

