#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"
#include "structs.h"

int struct_align();
void encode_final();
short matrix_final(int a, int b, int c);
void bluntEnd_final(int c);
long scoreM_final(long a, long b, long c, long g, long h);
long scoreIx_final(long a, long b, long c, long g, long h);
long scoreIy_final(long a, long b, long c, long g, long h);
void trace_final(int a, int b, int c, short TRstart);
void write2aln_final(long c, char **aligns);
struct CLUSTERdata *cluster(long c);
int multiple(struct CLUSTERdata *clust, int c, int a);

extern struct SEQdata *SEQ;
struct ALNdata *aln_final;
extern int number_of_seqs;

/* ----------------------------------------------------------------------- */

void encode_final(){
  
  int a=0, b=0;

  fprintf(stdout, "Encoding data for structure based alignment ..\n");
  
  while(SEQ[a].seq){
    SEQ[a].letter=(struct LETTERdata*)space((SEQ[a].len+1)*sizeof(struct LETTERdata));
    while(SEQ[a].seq[b]){
      SEQ[a].letter[b].nucl = SEQ[a].seq[b];
      SEQ[a].letter[b].dotbracket = SEQ[a].struc[b];
      b++;
    }
    SEQ[a].letter[b].nucl = 0;
    b=0;
    a++;
  }
  fprintf(stdout, ".. done.\n");
}

/* ----------------------------------------------------------------------- */

int struct_align(){

  int c=0, a=0, b=1, z, d;
  struct CLUSTERdata *clust = NULL;
  short TRstart;

  fprintf(stdout, "Structure based pairwise alignments ..\n");
  while(SEQ[a].seq){
    while(SEQ[b].seq){
      c++;
      b++;
    }
    a++;
    b=a+1;
  }
  aln_final=(struct ALNdata*)space(c*sizeof(struct ALNdata));
  c=0;
  a=0;
  b=1;
  while(SEQ[a].seq){
    while(SEQ[b].seq){
      fprintf(stdout, "  Alignment %i of sequences %i : %i ..", c+1, a+1, b+1);
      TRstart = matrix_final(a, b, c);
      fprintf(stdout, ". done. Score: %li\n", aln_final[c].score);
      z = SEQ[a].len + SEQ[b].len +1;
      aln_final[c].alignment = (struct LETTERdata**)space(3*sizeof(struct LETTERdata*));
      aln_final[c].alignment[0] = (struct LETTERdata*)space(z*sizeof(struct LETTERdata));
      aln_final[c].alignment[1] = (struct LETTERdata*)space(z*sizeof(struct LETTERdata));
      aln_final[c].alignment[2] = NULL;
      trace_final(a, b, c, TRstart);
      b++;
      c++;
    }
    a++;
    b=a+1;
  }
  fprintf(stdout, "Structure based profile alignments ..\n");
  clust=cluster(c);
  d = multiple(clust, c, a);
  fprintf(stdout, ".. finished.\n");
  return(d);
}

/* ----------------------------------------------------------------------- */

short matrix_final(int a, int b, int c){

  short TRstart=0;
  int h=0, f=0, g;
  
  aln_final[c].no = (int*)space(number_of_seqs * sizeof(int));
  
  for(h=0; h < number_of_seqs; h++)   aln_final[c].no[h]=0;
  aln_final[c].no[0]=a+1;
  aln_final[c].no[1]=b+1;
  aln_final[c].seqname = NULL;
  aln_final[c].seqname = (char**)space(3*sizeof(char*));
  aln_final[c].seqname[0] = NULL;
  aln_final[c].seqname[1] = NULL;
  aln_final[c].seqname[2] = NULL; 
  aln_final[c].seqname[0]= (char*)space(512 * sizeof(char));
  aln_final[c].seqname[1]= (char*)space(512 * sizeof(char));
  aln_final[c].seqname[0] = SEQ[a].seqname;
  aln_final[c].seqname[1] = SEQ[b].seqname;
  aln_final[c].SCmatrix = (int***)space(3*sizeof(int**));
  aln_final[c].TRmatrix=(char***)space(3*sizeof(char**));
  for(h=0; h<3; h++)    aln_final[c].TRmatrix[h] = (char**)space((SEQ[b].len)*sizeof(char*));
  for(h=0; h<3; h++)    aln_final[c].SCmatrix[h]=(int**)space((SEQ[b].len+1)*sizeof(int*));
  for(h=0; h<3; h++)    aln_final[c].SCmatrix[h][0]=(int*)space((SEQ[a].len+1)*sizeof(int));
  for(h=0; h < (SEQ[a].len+1); h++){
    aln_final[c].SCmatrix[0][0][h]=f;
    aln_final[c].SCmatrix[1][0][h]=f;
    aln_final[c].SCmatrix[2][0][h]=f;
   /*  f=f-1; */
  }
/*   f=-1; */
  for(g=1; g < (SEQ[b].len+1); g++){
    for(h=0; h<3; h++){
      aln_final[c].SCmatrix[h][g]=(int*)space((SEQ[a].len+1)*sizeof(int));
      aln_final[c].TRmatrix[h][g-1]=(char*)space((SEQ[a].len+1)*sizeof(char));
      aln_final[c].SCmatrix[h][g][0]=f;
    }
   /*  f=f-1; */
    for(h=1; h < (SEQ[a].len+1); h++){
      aln_final[c].SCmatrix[0][g][h] = scoreM_final(a, b, c, g, h);
      aln_final[c].SCmatrix[1][g][h] = scoreIx_final(SEQ[a].len, SEQ[b].len, c, g, h);
      aln_final[c].SCmatrix[2][g][h] = scoreIy_final(SEQ[a].len, SEQ[b].len, c, g, h);
    }
    free(aln_final[c].SCmatrix[0][g-1]);
    free(aln_final[c].SCmatrix[1][g-1]);
    free(aln_final[c].SCmatrix[2][g-1]);
  }
  g=g-1;
  h=h-1;
  if((aln_final[c].SCmatrix[0][g][h] >= aln_final[c].SCmatrix[1][g][h]) &&
     (aln_final[c].SCmatrix[0][g][h] >= aln_final[c].SCmatrix[2][g][h])){
    aln_final[c].score = aln_final[c].SCmatrix[0][g][h];
    TRstart = 0;
  }
  if((aln_final[c].SCmatrix[1][g][h] >= aln_final[c].SCmatrix[2][g][h]) &&
     (aln_final[c].SCmatrix[1][g][h] > aln_final[c].SCmatrix[0][g][h])){
    aln_final[c].score = aln_final[c].SCmatrix[1][g][h];
    TRstart = 1;
  }
  if((aln_final[c].SCmatrix[2][g][h] > aln_final[c].SCmatrix[1][g][h]) &&
     (aln_final[c].SCmatrix[2][g][h] > aln_final[c].SCmatrix[0][g][h])){
    aln_final[c].score = aln_final[c].SCmatrix[2][g][h];
    TRstart = 2;
  }
  free(aln_final[c].SCmatrix[0][g]);
  free(aln_final[c].SCmatrix[1][g]);
  free(aln_final[c].SCmatrix[2][g]);
  free(aln_final[c].SCmatrix[0]);
  free(aln_final[c].SCmatrix[1]);
  free(aln_final[c].SCmatrix[2]);
  free(aln_final[c].SCmatrix);
  
  return(TRstart);
}

/* ----------------------------------------------------------------------- */

void trace_final(int a, int b, int c, short TRstart){
  
  int x, y, z, i, r=1, s=1;
  short d;
  struct LETTERdata empty;
 
  empty.nucl = '-';
  empty.dotbracket = '-'; 

  x=SEQ[a].len;
  y=SEQ[b].len;
  z=x+y+1;
  d = TRstart;
  
  for(i=0; i<z; i++){
    aln_final[c].alignment[0][i].nucl = '-';
    aln_final[c].alignment[1][i].nucl = '-';
    aln_final[c].alignment[0][i].dotbracket = '-';
    aln_final[c].alignment[1][i].dotbracket = '-';

  }
  z--;
  aln_final[c].alignment[0][z].nucl = 0;
  aln_final[c].alignment[1][z].nucl = 0;
  z--;
  x--;
  y--;

  while(x || y || r || s){
    if(d==0){
      if(r)   aln_final[c].alignment[0][z] = SEQ[a].letter[x];
      if(s)   aln_final[c].alignment[1][z] = SEQ[b].letter[y];
      switch(aln_final[c].TRmatrix[d][y][x]){
      case '1':     d=0;	break;
      case '2':     d=1;	break;
      case '3':     d=2;	break;
      default: fprintf(stderr, "Fatal error 1 in traceback!\n");  exit(1);
      }
      z--;
      if(x)  x--;
      else  r=0;
      if(y)  y--;
      else s=0;
      continue;
    }
    if(d==1){
      if(r)   aln_final[c].alignment[0][z] = SEQ[a].letter[x];
      aln_final[c].alignment[1][z] = empty;
      switch(aln_final[c].TRmatrix[d][y][x]){
      case '1':     d=0;	break;
      case '2':     d=1; 	break;
      case '3':     d=2;	break;
      default: fprintf(stdout, "Fatal error 2 in traceback!\n");  exit(2);
      }
      z--;
      if(x) x--;
      else r=0;
      if(!x && !y && !r && s)  d=2;
      continue;
    }
    if(d==2){
      aln_final[c].alignment[0][z] = empty;
      if(s)   aln_final[c].alignment[1][z] = SEQ[b].letter[y];
      switch(aln_final[c].TRmatrix[d][y][x]){
      case '1':     d=0;	break;
      case '2':     d=1; 	break;
      case '3':     d=2;	break;
      default: fprintf(stdout, "Fatal error 3 in traceback!\n");  exit(3);
      }
      z--;
      if(y)   y--;
      else   s=0;
      if(!x && !y && !s && r)  d=1;
      continue;
    }
  }
  for(x=0; x<3; x++){
    for(y=0; y<SEQ[b].len; y++){
      free(aln_final[c].TRmatrix[x][y]);
    }
    free(aln_final[c].TRmatrix[x]);
  }
  free(aln_final[c].TRmatrix);
  bluntEnd_final(c);
}
