#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"
#include "structs.h"
#include "PS_dot.h"

struct CLUSTERdata *cluster(int c);
int multiple(struct CLUSTERdata *clust, int c, int a);
void findPartn(int c, struct CLUSTERdata clust);
short multMx(struct ALNdata tempaln[2], int c);
void bluntEnd_final(int c);
void output_div();
void check_final();
void multTrace(struct ALNdata tempaln[2], int c, short TRstart);
int MscoreM_final(struct ALNdata tempaln[2], int c, int g, int h);
int MscoreIx_final(int a, int b, int c, int g, int h);
int MscoreIy_final(int a, int b, int c, int g, int h);
char *consensus(int c, int r);

extern struct SEQdata *SEQ;
extern struct ALNdata *aln_final;
extern int number_of_seqs;
extern int align_only;

/* -------------------------------------------------------------------- */

struct CLUSTERdata *cluster(int c){
  
  int a=0, b=0, g, d=0, e=0, i, temp_b=0, temp_g=0, x=0, y=0, m, n, z;
  struct CLUSTERdata *clust = NULL;
  long HighScore = -100000000, allscore = 0, **all_pairw_scores = NULL;
  float scoreCL;
  FILE *fp = NULL;
  
 
  while(SEQ[a].seq)  a++;
  all_pairw_scores = (long**)space(a*sizeof(long*));
  for(b=0; b < a; b++){
    all_pairw_scores[b] = (long*)space(a*sizeof(long));
  }
  
  for(i=0; i<c; i++){
    all_pairw_scores[aln_final[i].no[0]-1][aln_final[i].no[1]-1] = aln_final[i].score;
    all_pairw_scores[aln_final[i].no[1]-1][aln_final[i].no[0]-1] = aln_final[i].score;
  }
  
  clust=(struct CLUSTERdata*)space((a+a+1)*sizeof(struct CLUSTERdata));
  for(b=0; b< (a+a+1); b++){
    clust[b].no = (int*)space((number_of_seqs+1) * sizeof(int));
    clust[b].melted1 = (int*)space((number_of_seqs+1) * sizeof(int));
    clust[b].melted2 = (int*)space((number_of_seqs+1) * sizeof(int));
  }
  
  b=0; 
  a=0;
  while(SEQ[a].seq){
    clust[a].no[0]=SEQ[a].no;
    clust[a].done=0;
    for(i=1; i < number_of_seqs; i++)  clust[a].no[i]=0;
    for(i=0; i < number_of_seqs; i++){
      clust[a].melted1[i]=0;
      clust[a].melted2[i]=0;
    }
    a++;
  }
  
  for(i=0; i< (number_of_seqs+1); i++){
    clust[a].no[i]=0;
    clust[a+1].no[i]=0;
    clust[a].melted1[i]=0;
    clust[a].melted2[i]=0;
  }
  
  z=2*a-1;
  while(a<z){
    for(b=0; b<(a-1); b++){
      if(clust[b].done) continue;
      for(g=b+1; g<a; g++){
	if(clust[g].done) continue;
	
	while(clust[b].no[d]){
	  while(clust[g].no[e]){
	    allscore = allscore + all_pairw_scores[clust[b].no[d]-1][clust[g].no[e]-1];
	    x++;
	    
	    /* 	    for(i=0; i<c; i++){ */
	    /* 	    	      if(((aln_final[i].no[0]==clust[b].no[d]) && */
	    /* 	    		  (aln_final[i].no[1]==clust[g].no[e])) || */
	    /* 	    		 ((aln_final[i].no[1]==clust[b].no[d]) && */
	    /* 	    		  (aln_final[i].no[0]==clust[g].no[e]))){ */
	    /* 	    		allscore=allscore+aln_final[i].score; */
	    /* 			printf("%li\n", allscore); */
	    /* 	       		x++; */
	    /* 	    		break; */
	    /* 	    	      } */
	    /* 	    	    } */
	    
	    e++;
	  }
	  e=0;
	  d++;
	}
	scoreCL= (float)allscore/(float)x;
	if(scoreCL>(float)(HighScore)){
	  HighScore=scoreCL;
	  temp_b=b;
	  temp_g=g;
	}
	x=0;
	allscore=0;
	d=0;
      }
    }
    clust[temp_b].done=1;
    clust[temp_g].done=1;
    x=0;
    y=0;
    while(clust[temp_b].no[x]){
      clust[a].no[y]=clust[temp_b].no[x];
      clust[a].melted1[x]=clust[temp_b].no[x];
      x++;
      y++;
    }
    x=0;
    while(clust[temp_g].no[x]){
      clust[a].no[y]=clust[temp_g].no[x];
      clust[a].melted2[x]=clust[temp_g].no[x];
      x++;
      y++;
    }
    HighScore = -100000000;
    a++;
  }
  
  m=0;
  n=0;
  fp=fopen("SALSA_guide_tree.txt", "w");
  while(!clust[m].no[1]) m++;
  while(clust[m].no[0]){
    fprintf(fp, "Cluster: %i   Sequence(s): ", m - number_of_seqs + 2);
    while(clust[m].no[n]){
      fprintf(fp, "%i", clust[m].no[n]);
      n++;
      if(clust[m].no[n])   fprintf(fp, ", ");
    }
    fprintf(fp, "\n");
    n=0;
    m++;
  }
  fclose(fp);
  
  a=0;
  while(SEQ[a].seq)  a++;
  for(b=0; b < a; b++){
    free(all_pairw_scores[b]);
  }
  free(all_pairw_scores);
  
  return(clust);
}

/* -------------------------------------------------------------------- */

int multiple(struct CLUSTERdata *clust, int c, int a){
 
  /* c=no of pair aligns, a=no of SEQs */

  int i, m, n, d;
  
  d=c;
  aln_final=(struct ALNdata*)realloc(aln_final, (c+a)*sizeof(struct ALNdata));
  if(align_only){
    for(m=c; m<(c+a); m++){
      aln_final[m].no = (int*)space((number_of_seqs+1) * sizeof(int));
      for(n=0; n < (number_of_seqs+1); n++)   aln_final[m].no[n] = 0;
    }
  }
  else {
  	for(m=c; m<(c+a); m++){
      aln_final[m].no = (int*)space(number_of_seqs * sizeof(int));
      for(n=0; n < number_of_seqs; n++)   aln_final[m].no[n] = 0;
    }
  }
  m=a;
  n=0;
  while(clust[m].no[0]){
    while(clust[m].no[n]){
      n++;
    }
    fprintf(stdout, "Alignment %i of cluster %i ..", c+1, m - number_of_seqs + 2);
    if(n==2){
      for(i=0; i<d; i++){
	if(((aln_final[i].no[0]==clust[m].no[0]) && 
	    (aln_final[i].no[1]==clust[m].no[1])) || 
	   ((aln_final[i].no[1]==clust[m].no[0]) && 
	    (aln_final[i].no[0]==clust[m].no[1]))){

	  aln_final[c] = aln_final[i];
	  break;
	}
      }
    }
    else    findPartn(c, clust[m]);
    fprintf(stdout, ". done. Score: %li\n", aln_final[c].score);
    c++;
    n=0;
    m++;
  }
  return(c);
}

/* -------------------------------------------------------------------- */

void findPartn(int c, struct CLUSTERdata clust){
  
  /* c == current aln_final */
  
  int d=0, h1=0, h2=0, i=0, q=0, e=0;
  struct ALNdata tempaln[2];
  short TRstart=0;
  
  while(clust.melted1[d]) d++;
  if(d==1){
    while(SEQ[h1].seq){
      if(SEQ[h1].no == clust.melted1[0])   break;
      else h1++;
    }
    tempaln[0].alignment = (struct LETTERdata**)space
      (2*sizeof(struct LETTERdata*));
    tempaln[0].seqname = (char**)space(2*sizeof(char*));
    tempaln[0].seqname[0] = (char*)space(256*sizeof(char));
    q=0;
    tempaln[0].alignment[0] = SEQ[h1].letter;
    strcpy(tempaln[0].seqname[0], SEQ[h1].seqname);
    free(SEQ[h1].seqname);
    tempaln[0].alignment[1] = NULL;
    tempaln[0].seqname[1] = NULL;
    tempaln[0].no = (int*)space(number_of_seqs * sizeof(int));
    tempaln[0].no[0] = SEQ[h1].no;
    tempaln[0].no[1] = 0;
  }
  else{
    if(d==0){
      fprintf(stderr, "Fatal error. Aborting.\n");
      exit(90);
    }
    h1=0;
    for(i=0; i<c; i++){
      while(clust.melted1[h1] || aln_final[i].no[h1]){
	if(clust.melted1[h1] == aln_final[i].no[h1]){
	  h1++;
	}
	else{
	  h1=0;
	  break;
	}
      }
      if(h1){
	q=0;
	e=0;
	while(aln_final[i].alignment[q])      q++;
	while(aln_final[i].alignment[0][e].nucl)    e++;

	tempaln[0] = aln_final[i];
	tempaln[0].alignment[q] = NULL;
	tempaln[0].seqname[q] = NULL;
	tempaln[0].no[q] = 0;
	
	break;
      }
    }
  }
  d=0;
  while(clust.melted2[d])    d++;
  if(d==1){
    while(SEQ[h2].seq){
      if(SEQ[h2].no == clust.melted2[0]) break;
      else h2++;
    }
    tempaln[1].alignment = (struct LETTERdata**)space
      (2*sizeof(struct LETTERdata*));
    tempaln[1].seqname = (char**)space(2*sizeof(char*));
    tempaln[1].alignment[0] = SEQ[h2].letter;
    tempaln[1].alignment[1] = NULL;
    tempaln[1].seqname[0] = (char*)space(256*sizeof(char));
    strcpy(tempaln[1].seqname[0], SEQ[h2].seqname);
    tempaln[1].seqname[1] = NULL;
    tempaln[1].no[0] = SEQ[h2].no;
    tempaln[1].no[1] = 0;
  }
  else{
    if(d==0){
      fprintf(stderr, "Fatal error. Aborting.\n");
      exit(91);
    }
    h2=0;
    for(i=0; i<c; i++){
      while(clust.melted2[h2] || aln_final[i].no[h2]){
	if(clust.melted2[h2] == aln_final[i].no[h2]){
	  h2++;
	}
	else{
	  h2=0;
	  break;
	}
      }
      if(h2){
	q=0;
	e=0;
	while(aln_final[i].alignment[q])      q++;
	while(aln_final[i].alignment[0][e].nucl)    e++;
	
	tempaln[1] = aln_final[i];
	tempaln[1].alignment[q] = NULL;
	tempaln[1].seqname[q] = NULL;
	tempaln[1].no[q] = 0;
	
	break;
      }
    }
  }
  TRstart = multMx(tempaln, c);
  multTrace(tempaln, c, TRstart);
}

/* -------------------------------------------------------------------- */

short multMx(struct ALNdata tempaln[2], int c){
  
  int a=0, b=0, f=0, g, h;
  short TRstart=0;
  
  while(tempaln[0].alignment[0][a].nucl){
    a++;
  }
  while(tempaln[1].alignment[0][b].nucl){
    b++;
  }
  /*  a horizontal, b vertikal  */
  aln_final[c].SCmatrix = (int***)space(3*sizeof(int**));
  aln_final[c].TRmatrix=(char***)space(3*sizeof(char**));
  for(h=0; h<3; h++)   aln_final[c].TRmatrix[h]=(char**)space(b*sizeof(char*));
  for(h=0; h<3; h++)   aln_final[c].SCmatrix[h]=(int**)space((b+1)*sizeof(int*));
  for(h=0; h<3; h++)   aln_final[c].SCmatrix[h][0]=(int*)space((a+1)*sizeof(int));
  
   for(h=0; h<(a+1); h++){
    aln_final[c].SCmatrix[0][0][h]=f;
    aln_final[c].SCmatrix[1][0][h]=f;
    aln_final[c].SCmatrix[2][0][h]=f;
    /*  f=f-1; */
  }
 /*  f=-1; */
   for(g=1; g<(b+1); g++){
    for(h=0; h<3; h++){
      aln_final[c].SCmatrix[h][g]=(int*)space((a+1)*sizeof(int));
      aln_final[c].TRmatrix[h][g-1]=(char*)space((a+1)*sizeof(char));
      aln_final[c].SCmatrix[h][g][0]=f;
    }
 
   /*  f=f-1; */
    for(h=1; h<(a+1); h++){
      aln_final[c].SCmatrix[0][g][h] = MscoreM_final(tempaln, c, g, h);
      aln_final[c].SCmatrix[1][g][h] = MscoreIx_final(a, b, c, g, h);
      aln_final[c].SCmatrix[2][g][h] = MscoreIy_final(a, b, c, g, h);
    }
    free(aln_final[c].SCmatrix[0][g-1]);
    free(aln_final[c].SCmatrix[1][g-1]);
    free(aln_final[c].SCmatrix[2][g-1]);
  }
  if(((aln_final[c].SCmatrix[0][b][a]) >= (aln_final[c].SCmatrix[1][b][a])) &&
     ((aln_final[c].SCmatrix[0][b][a]) >= (aln_final[c].SCmatrix[2][b][a]))){
    aln_final[c].score = aln_final[c].SCmatrix[0][b][a];
    TRstart = 0;
  }
  else if(((aln_final[c].SCmatrix[1][b][a]) > (aln_final[c].SCmatrix[0][b][a])) &&
	  ((aln_final[c].SCmatrix[1][b][a]) >= (aln_final[c].SCmatrix[2][b][a]))){
    aln_final[c].score = aln_final[c].SCmatrix[1][b][a];
    TRstart = 1;
  }
  else if(((aln_final[c].SCmatrix[2][b][a]) > (aln_final[c].SCmatrix[0][b][a])) &&
	  ((aln_final[c].SCmatrix[2][b][a]) > (aln_final[c].SCmatrix[1][b][a]))){
    aln_final[c].score = aln_final[c].SCmatrix[2][b][a];
    TRstart = 2;
  }
  free(aln_final[c].SCmatrix[0][b]);
  free(aln_final[c].SCmatrix[1][b]);
  free(aln_final[c].SCmatrix[2][b]);
  free(aln_final[c].SCmatrix[0]);
  free(aln_final[c].SCmatrix[1]);
  free(aln_final[c].SCmatrix[2]);
  free(aln_final[c].SCmatrix);
  return(TRstart);
}

/* -------------------------------------------------------------------- */

void multTrace(struct ALNdata tempaln[2], int c, short TRstart){
  
  int x=0, y=0, z, h, n=0;
  short d, r=1, s=1;
  int a=0, b=0, e, f, q=0, p=0;
  struct LETTERdata empty;

  empty.nucl = '-';
  empty.dotbracket = '-';
  
  while(tempaln[0].alignment[a])             a++;
  while(tempaln[1].alignment[b])             b++;
  while(tempaln[0].alignment[0][x].nucl)     x++;
  while(tempaln[1].alignment[0][y].nucl)     y++;
  
  z = x+y;
  d = TRstart;
  
  aln_final[c].alignment = (struct LETTERdata**) space ((a+b+1)*sizeof(struct LETTERdata*));
  aln_final[c].seqname = (char**)space((a+b+1)*sizeof(char*));
  
  for(e=0; e<(a+b); e++){
    aln_final[c].alignment[e]=(struct LETTERdata*)space ((z+1)*sizeof(struct LETTERdata));
    aln_final[c].seqname[e]=(char*)space(256*sizeof(char));
    for(h=0; h<z; h++){
      aln_final[c].alignment[e][h].nucl = '-';
      aln_final[c].alignment[e][h].dotbracket = '-';
    }
    aln_final[c].alignment[e][z].nucl = 0;
  }
  
  aln_final[c].alignment[a+b]=NULL;
  aln_final[c].seqname[a+b]=NULL;
  e=0;
  f=0;
  
  while(tempaln[0].no[e]){
    aln_final[c].no[f] = tempaln[0].no[e];
    strcpy(aln_final[c].seqname[f], tempaln[0].seqname[e]);
    e++;
    f++;
  }
  e=0;
  while(tempaln[1].no[e]){
    aln_final[c].no[f] = tempaln[1].no[e];
    strcpy(aln_final[c].seqname[f], tempaln[1].seqname[e]);
    e++;
    f++;
  }
  aln_final[c].seqname[f] = NULL;
  aln_final[c].no[f] = 0;
  
  z--;
  x--;
  y--;
  n=y;
  
  while(x || y || r || s){
    if(d==0){
      if(r){
	while(tempaln[0].alignment[q]){
	  aln_final[c].alignment[p][z] = tempaln[0].alignment[q][x];
	  p++;
	  q++;
	}
      }
      else {
	while(tempaln[0].alignment[q]){
	  q++;
	  p++;
	}
      }
      q=0;
      if(s){
	while(tempaln[1].alignment[q]){
	  aln_final[c].alignment[p][z] = tempaln[1].alignment[q][y];
	  p++;
	  q++;
	}
      }
      
      switch(aln_final[c].TRmatrix[d][y][x]){
      case '1': 	d=0;    	break;
      case '2': 	d=1;    	break;
      case '3': 	d=2;    	break;
      default: fprintf(stderr, "Fatal error 1!\n");  exit(1);
      }
      
      z--;
      
      if(x)  x--;
      else  r=0;
      
      if(y)  y--;
      else  s=0;
      
      q=0;
      p=0;
      continue;
    }
    
    if(d==1){
      if(r){
	while(tempaln[0].alignment[q]){
	  aln_final[c].alignment[p][z] = tempaln[0].alignment[q][x];
	  p++;
	  q++;
	}
      }
      else {
	while(tempaln[0].alignment[q]){
	  q++;
	  p++;
	}
      }
      q=0;
      while(tempaln[1].alignment[q]){
	aln_final[c].alignment[p][z] = empty;
	p++;
	q++;
      }
      switch(aln_final[c].TRmatrix[d][y][x]){
      case '1': 	d=0;    	break;
      case '2': 	d=1;    	break;
      case '3': 	d=2;    	break;
      default: fprintf(stderr, "Fatal error 2!\n");  
	exit(2); 
      }
      z--;
      if(x)  x--;
      else  r=0;
      if(!x && !y && !r && s)  d=2;
      q=0;
      p=0;
      continue;
    }
    
    if(d==2){
      while(tempaln[0].alignment[q]){
	aln_final[c].alignment[p][z] = empty;
	p++;
	q++;
      }
      q=0;
      if(s){
	while(tempaln[1].alignment[q]){
	  aln_final[c].alignment[p][z] = tempaln[1].alignment[q][y];
	  p++;
	  q++;
	}
      }
      switch(aln_final[c].TRmatrix[d][y][x]){
      case '1': 	d=0;    	break;
      case '2': 	d=1;    	break;
      case '3': 	d=2;    	break;
      default: fprintf(stderr, "Fatal error 3!\n");  exit(3);
      }
      z--;
      if(y)  y--;
      else   s=0;
      if(!x && !y && !s && r)  d=1;
      q=0;
      p=0;
      continue;
    }
  }
  
  for(a=0; a<3; a++){
    for(b=0; b<(n); b++){
      free(aln_final[c].TRmatrix[a][b]);
    }
    free(aln_final[c].TRmatrix[a]);
  }
  free(aln_final[c].TRmatrix);
  
  bluntEnd_final(c);
}

/* -------------------------------------------------------------------- */

void bluntEnd_final(int c){
  
  int a=0, b=0, min=1000000, d=0, e;
  struct LETTERdata *temp = NULL;
  
  while(aln_final[c].alignment[a]){
    while(aln_final[c].alignment[a][b].nucl){
      if(aln_final[c].alignment[a][b].nucl == '-')      b++;
      else break;
    }
    if(b<min) min=b;
    a++;
    b=0;
  }
  
  while(aln_final[c].alignment[0][d].nucl)       d++;
  a=0;
  b=0;
  e=min;
  
  while(aln_final[c].alignment[a]){
    temp=(struct LETTERdata*)space((d-min+1)*sizeof(struct LETTERdata));
    while(aln_final[c].alignment[a][e].nucl){
      temp[b] = aln_final[c].alignment[a][e];
      b++;
      e++;
    }
    temp[b].nucl = 0;
    free(aln_final[c].alignment[a]);
    aln_final[c].alignment[a]=(struct LETTERdata*)space((d-min+1)*sizeof(struct LETTERdata));
    b=0;
    while(temp[b].nucl){
      aln_final[c].alignment[a][b] = temp[b];
      b++;
    }
    aln_final[c].alignment[a][b].nucl = 0;
    free(temp);
    b=0;
    e=min;
    a++;
  }
}



/* -------------------------------------------------------------------- */






void output_div(int c){

  FILE *result = NULL, *result_struct = NULL, *cons_file = NULL;
  FILE *combined_A = NULL;   FILE *combined_B = NULL;
  int b=0, r=0, s=0, t, u=0, i, max_name_len=0, m, line_len, c_counter;
  int cons_plot, bb =0;
  char *date = NULL, *consensus_struc = NULL, *consensus_seq = NULL;
  
  c--;  
  while(aln_final[c].alignment[0][r].nucl)     r++;
  
  consensus_struc = (char*)space((r+1)*sizeof(char));
  consensus_struc = consensus(c, r);
  cons_file = fopen("SALSA_consensus.txt", "w");
  fprintf(cons_file, "%s\n", consensus_struc);
  fclose(cons_file);
  consensus_seq = (char*)space((strlen(consensus_struc)+2)*sizeof(char));
  
  for(b=0; b< strlen(consensus_struc); b++){
    consensus_seq[b] = '';
  }
  
  consensus_seq[b] = '\0';
  cons_plot = PS_rna_plot (consensus_seq, consensus_struc, "SALSA_consensus_ss.ps");
  

  combined_A = fopen("SALSA_structaln_comb_typeA.fas", "w");
  combined_B = fopen("SALSA_structaln_comb_typeB.fas", "w");
  b=0; 
  while(aln_final[c].seqname[b]){
    fprintf(combined_A, ">%s\n", aln_final[c].seqname[b]);
    fprintf(combined_B, ">%s\n", aln_final[c].seqname[b]);
    bb=0;
    while(aln_final[c].alignment[b][bb].nucl){
      fprintf(combined_A, "%c", aln_final[c].alignment[b][bb].nucl);
      fprintf(combined_B, "%c", aln_final[c].alignment[b][bb].nucl);
      bb++;
    }
    fprintf(combined_A, "\n");    
    fprintf(combined_B, "\n>%s\n", aln_final[c].seqname[b]);
    
    bb=0;
    while(aln_final[c].alignment[b][bb].nucl){
      fprintf(combined_A, "%c", aln_final[c].alignment[b][bb].dotbracket);
      fprintf(combined_B, "%c", aln_final[c].alignment[b][bb].dotbracket);
      bb++;
    }
    fprintf(combined_A, "\n");
    fprintf(combined_B, "\n");
    b++;
  }
  fclose(combined_A);
  fclose(combined_B);




  b=0;
  while(aln_final[c].seqname[b]){
    if(strlen(aln_final[c].seqname[b]) > max_name_len)  max_name_len = strlen(aln_final[c].seqname[b]);
    if(strlen(aln_final[c].seqname[b]) > 30){
      aln_final[c].seqname[b][30] = '\0';
      max_name_len = 30;
    }
    b++;
  }
  if(max_name_len > 20) line_len = 50;
  else line_len = 60;
  

  b=0;
  date=time_stamp();
  result = fopen("SALSA_structaln_sequ.aln", "w");
  result_struct = fopen("SALSA_structaln_struct.aln", "w");
  
 

  
  r=0;
  while(aln_final[c].alignment[0][r].nucl)     r++;
  s = r%line_len;
  r = r/line_len;
  fprintf(result,"CLUSTAL W style - RNAsalsa structaln alignment  %s\n\n", date);
  fprintf(result_struct,"CLUSTAL W style - RNAsalsa - aligned structures  %s\n\n", date);
  
  /* fprintf(all_folds_aln, "CLUSTAL W style - aligned folds     %s\n\n", date); */
  
  for(t=0; t<r; t++){
    while(aln_final[c].seqname[b]){
      fprintf(result, "%s", aln_final[c].seqname[b]);
      fprintf(result_struct, "%s", aln_final[c].seqname[b]);
      
      /*  fprintf(all_folds_aln, "%s", aln_final[c].seqname[b]); */
      
      for(m=0; m<=(max_name_len - strlen(aln_final[c].seqname[b])); m++){
	fprintf(result, " ");
	fprintf(result_struct, " ");
	/* fprintf(all_folds_aln, " "); */
      }
      fprintf(result, "     ");
      fprintf(result_struct, "     ");
      /*  fprintf(all_folds_aln, "     "); */
      
      for(i=u; i<u+line_len; i++){
	fprintf(result,"%c",aln_final[c].alignment[b][i].nucl);
	fprintf(result_struct,"%c",aln_final[c].alignment[b][i].dotbracket);
	/* 	fprintf(all_folds_aln,"%c",aln_final[c].alignment[b][i].dotbracket); */
      }
      
      fprintf(result,"\n");
      fprintf(result_struct,"\n");
      /*  fprintf(all_folds_aln,"\n"); */
      b++;
    }
    fprintf(result,"  \n\n");
    fprintf(result_struct,"  \n\n");
    /*  fprintf(all_folds_aln,"  \n\n"); */
    b=0;
    u+=line_len;
  }
  
  if(s){
    while(aln_final[c].seqname[b]){
      fprintf(result, "%s", aln_final[c].seqname[b]);
      fprintf(result_struct, "%s", aln_final[c].seqname[b]);
      /*  fprintf(all_folds_aln, "%s", aln_final[c].seqname[b]); */
      for(m=0; m<=(max_name_len - strlen(aln_final[c].seqname[b])); m++){
	fprintf(result, " ");
	fprintf(result_struct, " ");
	/*  fprintf(all_folds_aln, " "); */
      }
      
      fprintf(result, "     ");
      fprintf(result_struct, "     ");
      /*  fprintf(all_folds_aln, "     "); */
      
      for(i=u; i<u+s; i++){
	fprintf(result, "%c", aln_final[c].alignment[b][i].nucl);
	fprintf(result_struct, "%c", aln_final[c].alignment[b][i].dotbracket);
	/* 	fprintf(all_folds_aln,"%c",aln_final[c].alignment[b][i].dotbracket); */
      }
      fprintf(result,"\n");
      fprintf(result_struct,"\n");
      /*  fprintf(all_folds_aln,"\n"); */
      b++;
    }
  }
  fprintf(result,"  \n");
  fprintf(result_struct,"  \n");
  /*   fprintf(all_folds_aln,"  \n"); */
  fclose(result);
  fclose(result_struct);
  
  while(aln_final[c].seqname[b]){
    free(aln_final[c].seqname[b]);
    b++;
  }
  free(aln_final[c].seqname);
}


/* -------------------------------------------------------------------- */


void check_final(){

  int a=0, b=0, c=0, d=0, e, f=0;
  char *testseq=NULL;
  
  while(aln_final[a].no[0]){
    a++;
  }
  a=a-1;
  while(aln_final[a].alignment[0][d].nucl)    d++; 
  while(aln_final[a].no[b]){
    testseq = (char*)space((d+1)*sizeof(char));
    for(e=0; e<d; e++){
      if(isalpha(aln_final[a].alignment[b][e].nucl)){
	testseq[f] = aln_final[a].alignment[b][e].nucl;
	f++;
      }
    }
    testseq[f] = '\0';
    while(SEQ[c].seq){
      if(aln_final[a].no[b] == SEQ[c].no){
	if(strcmp(testseq, SEQ[c].seq)){
	  fprintf(stdout, "BAD ALIGNMENT ERROR! SEQ no %i\n", c);
	  exit(27);
	}
	else break;
      }
      else c++;
    }
    free(testseq);
    b++;
    c=0;
    f=0;
  }
}


