#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "utils.h"
#include "structs.h"
/* #include "scoretable.h" */

int MscoreM_final(struct ALNdata tempaln[2], int c, int g, int h);
int MscoreIx_final(int a, int b, int c, int g, int h);
int MscoreIy_final(int a, int b, int c, int g, int h);

int scoreM_final(int a, int b, int c, int g, int h);
int scoreIx_final(int a, int b, int c, int g, int h);
int scoreIy_final(int a, int b, int c, int g, int h);

extern struct SEQdata *SEQ;
extern struct ALNdata *aln_final;
extern int GAP_OPEN;
extern int GAP_EXT;
extern int NS_MATCH;
extern int NS_MISM;

/* ----------------------------------------------------------------------- */

int scoreM_final(int a, int b, int c, int g, int h){
  
  int s = 0, sM, sIx, sIy;
  int ma, pa, mb, pb;
  
  int matching_bp[6][6] = {
 /*  A  C  G  U  T  else*/
    {1, 0, 0, 0, 0, 0}, /* A */
    {0, 1, 0, 0, 0, 0}, /* C */
    {0, 0, 1, 0, 0, 0}, /* G*/
    {0, 0, 0, 1, 1, 0}, /* U */
    {0, 0, 0, 1, 1, 0}, /* T */
    {0, 0, 0, 0, 0, 0}, /* else */
  };
  int matching_bp_struct[6][6] = {
 /*  A  C  G  U  T  else*/
    {1, 0, 2, 0, 0, 0}, /* A */
    {0, 1, 0, 2, 2, 0}, /* C */
    {2, 0, 1, 0, 0, 0}, /* G*/
    {0, 2, 0, 1, 1, 0}, /* U */
    {0, 2, 0, 1, 1, 0}, /* T */
    {0, 0, 0, 0, 0, 0}, /* else */
  };
  
  int matching_bp_struct_CORRESPONDING[6][6][6][6] = {
              
             /* A */             /* C */             /* G*/            /* U */              /* T */            /* else */
               
   /*  A  C  G  U  T  else*/
    {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},}, /* A */
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},}, /* C */
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},}, /* G*/           /* A */
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},}, /* U */
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},}, /* T */
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},}, /* else */
    
    {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},                   /* C */
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},},
    
    {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},                   /* G*/ 
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},},
    
    {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},                    /* U */
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},},
    
    {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},                   /* T */
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},},

    {{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},                   /* else */
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},
     {{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0},},},

};
  
  int x, y;
  int xx,yy;
  
  h=h-1;
  g=g-1;
  
  if(SEQ[a].letter[h].nucl == 'A') x = 0;
  else if(SEQ[a].letter[h].nucl == 'C') x = 1;
  else if(SEQ[a].letter[h].nucl == 'G') x = 2;
  else if(SEQ[a].letter[h].nucl == 'U') x = 3;
  else if(SEQ[a].letter[h].nucl == 'T') x = 4;
  else x = 5;
	
  if(SEQ[b].letter[g].nucl == 'A') y = 0;
  else if(SEQ[b].letter[g].nucl == 'C') y = 1;
  else if(SEQ[b].letter[g].nucl == 'G') y = 2;
  else if(SEQ[b].letter[g].nucl == 'U') y = 3;
  else if(SEQ[b].letter[g].nucl == 'T') y = 4;
  else y = 5;
  
  
  if((SEQ[a].letter[h].dotbracket != '.') &&  (SEQ[b].letter[g].dotbracket != '.')) {
    if(SEQ[a].letter[h].dotbracket == SEQ[b].letter[g].dotbracket) {
      if(SEQ[a].letter[h].dotbracket != 'x'){  /* eigentlich hinfaellig, kann kein 'x' sein. */
	switch(SEQ[a].letter[h].dotbracket){
	case '(':
	  ma = 1;
	  pa = h;
	  while(ma){
	    pa ++;
	    if(SEQ[a].letter[pa].dotbracket == '(') ma++;
	    if(SEQ[a].letter[pa].dotbracket == ')') ma--;
	  }
	  break;
	case ')':
	  ma = 1;
	  pa = h;
	  while(ma){
	    pa --; 
	    if(SEQ[a].letter[pa].dotbracket == '(') ma --;
	    if(SEQ[a].letter[pa].dotbracket == ')') ma ++;
	  }
	  break;
	default: severe_error(377); /* impossible signs in structure. */
	}
	
	switch(SEQ[b].letter[g].dotbracket){
	case '(':
	  mb = 1;
	  pb = g;
	  while(mb){
	    pb ++; 
	    if(SEQ[b].letter[pb].dotbracket == '(') mb++;
	    if(SEQ[b].letter[pb].dotbracket == ')') mb--;
	  }
	  break;
	case ')':
	  mb = 1;
	  pb = g;
	  while(mb){
	    pb --; 
	    if(SEQ[b].letter[pb].dotbracket == '(') mb --;
	    if(SEQ[b].letter[pb].dotbracket == ')') mb ++;
	  }
	  break;
	default: severe_error(377); /* impossible signs in structure. */
	}
	if(SEQ[a].letter[pa].nucl == 'A') xx = 0;
	else if(SEQ[a].letter[pa].nucl == 'C') xx = 1;
	else if(SEQ[a].letter[pa].nucl == 'G') xx = 2;
	else if(SEQ[a].letter[pa].nucl == 'U') xx = 3;
	else if(SEQ[a].letter[pa].nucl == 'T') xx = 4;
	else xx = 5;
	
	if(SEQ[b].letter[pb].nucl == 'A') yy = 0;
	else if(SEQ[b].letter[pb].nucl == 'C') yy = 1;
	else if(SEQ[b].letter[pb].nucl == 'G') yy = 2;
	else if(SEQ[b].letter[pb].nucl == 'U') yy = 3;
	else if(SEQ[b].letter[pb].nucl == 'T') yy = 4;
	else yy = 5;
	
	if(((matching_bp_struct[xx][yy]) + (matching_bp_struct[x][y])) == 4)     s = s + NS_MISM;
	
	else {	
	  if(matching_bp_struct[xx][yy])  s = s + NS_MATCH;
	  else   s = s + NS_MISM;
	  if(matching_bp_struct[x][y])  s = s + NS_MATCH;
	  else   s = s + NS_MISM;
	}
      }
      else {
	if(matching_bp[x][y])  s = s + NS_MATCH;
	else   s = s + NS_MISM;
      }
    }
    else {
      if(matching_bp[x][y])  s = s + NS_MATCH;
      else   s = s + NS_MISM;
    }
  }
  else {
    if(matching_bp[x][y])  s = s + NS_MATCH;
    else   s = s + NS_MISM;
  }
  
  /***/
 
  sM = aln_final[c].SCmatrix[0][g][h] + s;
  sIx = aln_final[c].SCmatrix[1][g][h] + s;
  sIy = aln_final[c].SCmatrix[2][g][h] + s;
  
  if((sM >= sIx) && (sM >= sIy)){
    aln_final[c].TRmatrix[0][g][h]='1';
    return(sM);
  }
  if((sIx > sM) && (sIx >= sIy)){
    aln_final[c].TRmatrix[0][g][h]='2';
    return(sIx);
  }
  if((sIy > sM) && (sIy > sIx)){
    aln_final[c].TRmatrix[0][g][h]='3';
    return(sIy);
  }
  return(0);
}

/* ----------------------------------------------------------------------- */
 
int scoreIx_final(int a, int b, int c, int g, int h){
 
  int sM, sIx, sIy;
 
  sM = aln_final[c].SCmatrix[0][g][h-1] + GAP_OPEN;
  sIx = aln_final[c].SCmatrix[1][g][h-1] + GAP_EXT;
  sIy = aln_final[c].SCmatrix[2][g][h-1] + GAP_OPEN;
 
 if(g == b)   sIx = aln_final[c].SCmatrix[1][g][h-1];
 
  if((sM >= sIx) && (sM >= sIy)){
    aln_final[c].TRmatrix[1][g-1][h-1]='1';
    return(sM);
  }
  if((sIx > sM) && (sIx >= sIy)){
    aln_final[c].TRmatrix[1][g-1][h-1]='2';
    return(sIx);
  }
  if((sIy > sM) && (sIy > sIx)){
    aln_final[c].TRmatrix[1][g-1][h-1]='3';
    return(sIy);
  }
  return(0);
}
 
/* ----------------------------------------------------------------------- */
 
int scoreIy_final(int a, int b, int c, int g, int h){
 
  int sM, sIx, sIy;
 
  sM = aln_final[c].SCmatrix[0][g-1][h] + GAP_OPEN;
  sIx = aln_final[c].SCmatrix[1][g-1][h] + GAP_OPEN;
  sIy = aln_final[c].SCmatrix[2][g-1][h] + GAP_EXT;
 
  if(h == a)   sIy = aln_final[c].SCmatrix[2][g-1][h];
 
  if((sM >= sIx) && (sM >= sIy)){
    aln_final[c].TRmatrix[2][g-1][h-1]='1';
    return(sM);
  }
  if((sIx > sM) && (sIx > sIy)){
    aln_final[c].TRmatrix[2][g-1][h-1]='2';
    return(sIx);
  }
  if((sIy > sM) && (sIy >= sIx)){
    aln_final[c].TRmatrix[2][g-1][h-1]='3';
    return(sIy);
  }
  return(0);
}
 
/* ----------------------------------------------------------------------- */

int MscoreM_final(struct ALNdata tempaln[2], int c, int g, int h){
 
  int x=0, y=0, z=0, s=0, sM=0, sIx=0, sIy=0, rest;
  int ma, pa, mb, pb;
  int matching_bp[6][6] = {
 /*  A  C  G  U  T  else*/
    {1, 0, 0, 0, 0, 0}, /* A */
    {0, 1, 0, 0, 0, 0}, /* C */
    {0, 0, 1, 0, 0, 0}, /* G*/
    {0, 0, 0, 1, 1, 0}, /* U */
    {0, 0, 0, 1, 1, 0}, /* T */
    {0, 0, 0, 0, 0, 0}, /* else */
  };
  int matching_bp_struct[6][6] = {
 /*  A  C  G  U  T  else*/
    {1, 0, 1, 0, 0, 0}, /* A */
    {0, 1, 0, 0, 0, 0}, /* C */
    {1, 0, 1, 0, 0, 0}, /* G*/
    {0, 0, 0, 1, 1, 0}, /* U */
    {0, 0, 0, 1, 1, 0}, /* T */
    {0, 0, 0, 0, 0, 0}, /* else */
  };
  int xx, yy;
  int xxx, yyy;
  
  g=g-1;
  h=h-1;
  
  while(tempaln[0].alignment[x]){
    while(tempaln[1].alignment[y]){
      
      if(isalpha(tempaln[0].alignment[x][h].nucl) && isalpha(tempaln[1].alignment[y][g].nucl)){
	
	if(tempaln[0].alignment[x][h].nucl == 'A') xx = 0;
	else if(tempaln[0].alignment[x][h].nucl == 'C') xx = 1;
	else if(tempaln[0].alignment[x][h].nucl == 'G') xx = 2;
	else if(tempaln[0].alignment[x][h].nucl == 'U') xx = 3;
	else if(tempaln[0].alignment[x][h].nucl == 'T') xx= 4;
	else xx = 5;
	
	if(tempaln[1].alignment[y][g].nucl == 'A') yy = 0;
	else if(tempaln[1].alignment[y][g].nucl == 'C') yy = 1;
	else if(tempaln[1].alignment[y][g].nucl == 'G') yy = 2;
	else if(tempaln[1].alignment[y][g].nucl == 'U') yy = 3;
	else if(tempaln[1].alignment[y][g].nucl == 'T') yy = 4;
	else yy = 5;
	
	if((tempaln[0].alignment[x][h].dotbracket != '.') &&  (tempaln[1].alignment[y][g].dotbracket != '.')) {
	  if(tempaln[0].alignment[x][h].dotbracket == tempaln[1].alignment[y][g].dotbracket) {
	    if(tempaln[0].alignment[x][h].dotbracket != 'x'){ 
	      
	      switch(tempaln[0].alignment[x][h].dotbracket){
	      case '(':
		ma=1;
		pa= h;
		while(ma){
		  pa ++; 
		  if(tempaln[0].alignment[x][pa].dotbracket == '(') ma++;
		  if(tempaln[0].alignment[x][pa].dotbracket == ')') ma--;
		}
		break;
	      case ')':
		ma = 1;
		pa = h;
		while(ma){
		  pa --; 
		  if(tempaln[0].alignment[x][pa].dotbracket == '(') ma --;
		  if(tempaln[0].alignment[x][pa].dotbracket == ')') ma ++;
		}
		break;
	      default: severe_error(377); /* impossible signs in structure. */
	      }
	      
	      switch(tempaln[1].alignment[y][g].dotbracket){
	      case '(':
		mb = 1;
		pb = g;
		while(mb){
		  pb ++; 
		  if(tempaln[1].alignment[y][pb].dotbracket == '(') mb++;
		  if(tempaln[1].alignment[y][pb].dotbracket == ')') mb--;
		}
		break;
	      case ')':
		mb = 1;
		pb = g;
		while(mb){
		  pb --; 
		  if(tempaln[1].alignment[y][pb].dotbracket == '(') mb --;
		  if(tempaln[1].alignment[y][pb].dotbracket == ')') mb ++;
		}
		break;
	      default: severe_error(377); /* impossible signs in structure. */
	      }
	      
	      if(tempaln[0].alignment[x][pa].nucl == 'A') xxx = 0;
	      else if(tempaln[0].alignment[x][pa].nucl == 'C') xxx = 1;
	      else if(tempaln[0].alignment[x][pa].nucl == 'G') xxx = 2;
	      else if(tempaln[0].alignment[x][pa].nucl == 'U') xxx = 3;
	      else if(tempaln[0].alignment[x][pa].nucl == 'T') xxx = 4;
	      else xxx = 5;
	      
	      if(tempaln[1].alignment[y][pb].nucl == 'A') yyy = 0;
	      else if(tempaln[1].alignment[y][pb].nucl == 'C') yyy = 1;
	      else if(tempaln[1].alignment[y][pb].nucl == 'G') yyy = 2;
	      else if(tempaln[1].alignment[y][pb].nucl == 'U') yyy = 3;
	      else if(tempaln[1].alignment[y][pb].nucl == 'T') yyy = 4;
	      else yyy = 5;
	      
	      if(matching_bp_struct[xxx][yyy])  s = s + NS_MATCH;
	      else   s = s + NS_MISM;
	    }
		if(matching_bp_struct[xx][yy])  s = s + NS_MATCH;	
	    else   s = s + NS_MISM;
	  }
	  else {
	  if(matching_bp[xx][yy])  s = s + NS_MATCH;
	  else   s = s + NS_MISM;
	}
	}
	else {
	  if(matching_bp[xx][yy])  s = s + NS_MATCH;
	  else   s = s + NS_MISM;
	}
      }
      
      y++;
      z++;
    }
    x++;
    y=0;
  }
  
  if(z){
    s = s*10;
    s = s/z;
    rest = s%10;
    s = s/10;
    if(rest >= 5)  s++;
  }
  sM = aln_final[c].SCmatrix[0][g][h] + s;
  sIx = aln_final[c].SCmatrix[1][g][h] + s;
  sIy = aln_final[c].SCmatrix[2][g][h] + s;
  
  if((sM >= sIx) && (sM >= sIy)){
    aln_final[c].TRmatrix[0][g][h]='1';
    return(sM);
  }
  if((sIx > sM) && (sIx >= sIy)){
    aln_final[c].TRmatrix[0][g][h]='2';
    return(sIx);
  }
  if((sIy > sM) && (sIy > sIx)){
    aln_final[c].TRmatrix[0][g][h]='3';
    return(sIy);
  }
  return(0);
}

/* ----------------------------------------------------------------------- */
 
int MscoreIx_final(int a, int b, int c, int g, int h){
 
  int sM, sIx, sIy;
 
  sM = aln_final[c].SCmatrix[0][g][h-1] + GAP_OPEN;
  sIx = aln_final[c].SCmatrix[1][g][h-1] + GAP_EXT;
  sIy = aln_final[c].SCmatrix[2][g][h-1] + GAP_OPEN;
 
  if(g == b)   sIx = aln_final[c].SCmatrix[1][g][h-1];
 
  if((sM >= sIx) && (sM >= sIy)){
    aln_final[c].TRmatrix[1][g-1][h-1]='1';
    return(sM);
  }
  if((sIx > sM) && (sIx >= sIy)){
    aln_final[c].TRmatrix[1][g-1][h-1]='2';
    return(sIx);
  }
  if((sIy > sM) && (sIy > sIx)){
    aln_final[c].TRmatrix[1][g-1][h-1]='3';
    return(sIy);
  }
  return(0);
}
 
/* ----------------------------------------------------------------------- */
 
int MscoreIy_final(int a, int b, int c, int g, int h){
 
  int sM, sIx, sIy;
 
  sM = aln_final[c].SCmatrix[0][g-1][h] + GAP_OPEN;
  sIx = aln_final[c].SCmatrix[1][g-1][h] + GAP_OPEN;
  sIy = aln_final[c].SCmatrix[2][g-1][h] + GAP_EXT;
 
  if(h == a)   sIy = aln_final[c].SCmatrix[2][g-1][h];
 
  if((sM >= sIx) && (sM >= sIy)){
    aln_final[c].TRmatrix[2][g-1][h-1]='1';
    return(sM);
  }
  if((sIx > sM) && (sIx > sIy)){
    aln_final[c].TRmatrix[2][g-1][h-1]='2';
    return(sIx);
  }
  if((sIy > sM) && (sIy >= sIx)){
    aln_final[c].TRmatrix[2][g-1][h-1]='3';
    return(sIy);
  }
  return(0);
}
 
