/* written by Roman R. Stocsits, 2007 */

struct input_options {
  char align_only_FN[512];
  char constraint_filename[512];
  char input_filename[512];
  int plot;
  int isFasta;
  float SR1;
  float SR2;
  float SR3;
  int kurzschluss;
};

struct LETTERdata {
  char nucl;
  char dotbracket;
};

struct conStruct {
  char *name;          
  char *sequence;     
  char *structure;    
  char *expStructure;  
  char *weakened;     
};

struct ALNdata {
  char ***TRmatrix;
  int ***SCmatrix;
  char **seqname;
  struct LETTERdata **alignment;
  long score;
  int *no; /* starts with 1! */
  char **lines;
  
};
struct CLUSTERdata {
  int *no; /* starts with 1! */
  int *melted1;
  int *melted2;
  short done;
};

struct SEQdata {
  struct LETTERdata *letter;
  int no;   /* starts with 1! */
  char *seq, *struc, *seqname, FN[512];
  int len;
};

struct seqStruct {
  
  char *name;          /* name of sequence in input alignment */
  char *sequence;      /* sequence without gaps */
  char *alnSequence;   /* sequence with gaps */
  char *structure;     /* secondary structure by RNAfold */
  char *structure_aln; /* secondary structure after final structure alignm.*/
  int length;          /* length of sequence/structure */
  float mfe;           /* mfe of folded structure */
  char *weakConstr;    /* copy of constraint.weakened, after shrinking */
  char *weakConstr2;   /* expanded constr., up to length of pairw. alignm.*/
  char **consStrucLst; /* list of consensus structures from pairwise alns */
  char *indivConstr;   /* each seq's individual folding constr. */
  struct LETTERdata *letter;   /* data entity for aln. */
  
};
